//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                    http://fx500.ru/silverfox |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

int OpSell(string Symb="",double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   if(Reverse==true) CloseBuys();
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   double SL=0;
   double TP=0;
   int Tick=0;
   RefreshRates();
   if(StLs>0) SL=Bid+StLs*Point;
   if(TkPr>0) TP=Bid-TkPr*Point;
   for(int i=1;i<=Requots;i++){
      Tick=OrderSend(Symb,OP_SELL,Vol,Bid,Slippage,SL,TP);
      if(Tick>0){
         if(UseSound==true) PlaySound(SND_Order);
         MaskOn();
         return(Tick);
         }
         else{
         if(GetLastError()!=135){
            Error(GetLastError());
            return(0);
            }
         }
      }
   if(UseSound==true) PlaySound(SND_Order);
   MaskOn();
   return(Tick);
   }

int OpBuy(string Symb="",double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   if(Reverse==true) CloseSells();
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   double SL=0;
   double TP=0;
   int Tick=0;
   RefreshRates();
   if(StLs>0) SL=Ask-StLs*Point;
   if(TkPr>0) TP=Ask+TkPr*Point;
   for(int i=1;i<=Requots;i++){
      Tick=OrderSend(Symb,OP_BUY,Vol,Ask,Slippage,SL,TP);
      if(Tick>0){
         if(UseSound==true) PlaySound(SND_Order);
         MaskOn();
         return(Tick);
         }
         else{
         if(GetLastError()!=135){
            Error(GetLastError());
            return(0);
            }
         }
      }
   if(UseSound==true) PlaySound(SND_Order);
   MaskOn();
   return(Tick);
   }
int BuyStop(string Symb,double Price,double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   if(Snd=="") Snd="ok.wav";
   double SL=0;
   double TP=0;
   int Tick=0;
   RefreshRates();
   if(StLs>0) SL=Price-StLs*Point;
   if(TkPr>0) TP=Price+TkPr*Point;
   if(OrderSend(Symb,OP_BUYSTOP,Vol,NormalizeDouble(Price,Digits),Slippage,SL,TP)>0) if(UseSound==true) PlaySound(SND_Pend);
   MaskOn();
   return(Tick);
   }
int SellStop(string Symb,double Price,double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   if(Snd=="") Snd="ok.wav";
   double SL=0;
   double TP=0;
   int Tick=0;
   RefreshRates();
   if(StLs>0) SL=Price+StLs*Point;
   if(TkPr>0) TP=Price-TkPr*Point;
   if(OrderSend(Symb,OP_SELLSTOP,Vol,NormalizeDouble(Price,Digits),Slippage,SL,TP)>0) if(UseSound==true) PlaySound(SND_Pend);
   MaskOn();
   return(Tick);
   }
void DeleteSellStops(){
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol()) OrderDelete(OrderTicket());
      }
   if(UseSound==true) PlaySound(SND_Pend);
   return;
   }
void DeleteBuyStops(){
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol()) OrderDelete(OrderTicket());
      }
   if(UseSound==true) PlaySound(SND_Pend);
   return;
   }
void CloseSells(string Snd="ok.wav"){
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         for(int j=1;j<=Requots;j++){
            RefreshRates();
            if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage)==true){
               j=Requots+1;
               if(UseSound==true) PlaySound(SND_Close);
               }
            }
         }
      }
   //PlaySound(SND_Close);
   return;
   }
void CloseBuys(string Snd="ok.wav"){
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         for(int j=1;j<=Requots;j++){
            RefreshRates();
            if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage)==true){
               j=Requots+1;
               if(UseSound==true) PlaySound(SND_Close);
               }
            }
         }
      }
   return;
   }
void CloseProfits(){
   int j;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderProfit()>=0 && OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         for(j=1;j<=Requots;j++){
            RefreshRates();
            if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage)==true){
               j=Requots+1;
               if(UseSound==true) PlaySound(SND_Close);
               }
            }
         }
      if(OrderProfit()>=0 && OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         for(j=1;j<=Requots;j++){
            RefreshRates();
            if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage)==true){
               j=Requots+1;
               if(UseSound==true) PlaySound(SND_Close);
               }
            }
         }
      }
   }
void CloseLoses(){
   int j;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderProfit()<0 && OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         for(j=1;j<=Requots;j++){
            RefreshRates();
            if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage)==true){
               j=Requots+1;
               if(UseSound==true) PlaySound(SND_Close);
               }
            }
         }
      if(OrderProfit()<0 && OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         for(j=1;j<=Requots;j++){
            RefreshRates();
            if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage)==true){
               j=Requots+1;
               if(UseSound==true) PlaySound(SND_Close);
               }
            }
         }
      }
   }

